from zope.formlib import form

import zope.i18nmessageid
_ = zope.i18nmessageid.MessageFactory('plone')

from Products.statusmessages.interfaces import IStatusMessage

class EditForm(form.EditForm):
    """Override EditForm to do sane redirection.
    """

    def update(self):
        form.EditForm.update(self)
        if self.status and not self.errors:
            # Set status message
            status = IStatusMessage(self.request)
            status.addStatusMessage(self.status, type=u'info')
            # Perform conditional redirect to the default view
            next = self.nextURL()
            if next:
                self.request.response.redirect(next)

    def nextURL(self):
        if getattr(self.context, 'absolute_url', None) is not None:
            return self.context.absolute_url()
        return None

    @form.action(_('label_save', u'Save'), condition=form.haveInputWidgets)
    def handle_save_action(self, action, data):
        if form.applyChanges(self.context, self.form_fields, data, self.adapters):
            zope.event.notify(zope.app.event.objectevent.ObjectModifiedEvent(self.context))
            self.status = _(u"Your changes have been saved.")
        else:
            self.status = _(u"No changes need to be saved.")

    @form.action(_('label_cancel', u'Cancel'))
    def handle_cancel_action(self, action, data):
        self.status = _(u"Edit cancelled.")
