from zope.app.component.hooks import setSite
from zope.app import zapi

from Products.Five.site.localsite import enableLocalSiteHook

from Acquisition import aq_parent
from OFS.Application import Application

from Products.listen.interfaces import IListLookup
from Products.listen.utilities.list_lookup import ListLookup

def importVarious(context):
    """
    Import various settings.
    
    Provisional handler that does initialization that is not yet taken
    care of by exising generic setup handlers.
    """
    
    site = context.getSite()
    logger = context.getLogger("listen")

    # Install the list lookup utility at the zope application root,
    # it seems a bit sketchy to be doing things at the zope application level
    # but this registry is really something that should be shared across
    # instances. We register it as a local, rather than global, utility because
    # it needs to have some persistent state.
    app = site
    # find the zope application root
    while app is not None and not isinstance(app, Application):
        app = aq_parent(app)

    # If we have the zope Application and the utility is not yet registered,
    # then register it.
    if (app is not None and zapi.queryUtility(IListLookup, default=None) is None):
        enableLocalSiteHook(app)
        setSite(app)
        sm = app.getSiteManager()
        if not sm.queryUtility(IListLookup):
            sm.registerUtility(IListLookup, ListLookup('list_lookup'))
            logger.info('IListLookup Utility registered at %s' % app)
        else:
            logger.info('IListLookup Utility already registered at %s' % app)
    else:
        logger.info('Nothing to import.')
